function _4DCC()
{
    var currencies = new Array();
    
    this.convert = function (from, to, volume) {
        if(! (from in currencies) || ! (to in currencies)) return false;
        
        if(from === "USD")
            return currencies[to].forOneUSD * volume;
        else if( to === "USD")
            return ( 1 / currencies[from].forOneUSD ) * volume;
        else
            return ( currencies[to].forOneUSD / currencies[from].forOneUSD ) * volume;
    };
    
    this.refreshRate = function(){
        chrome.storage.local.get(null, function(data){
            var today = new Date();
            var yesterday = new Date(data.last_refresh);
            if(yesterday.getDate() !== today.getDate()) {
                get_exchange_rates();
                get_bitcoin();
                chrome.storage.local.set(currencies);
            }
        });
        
    };
    
    this.getCurrencies = function(){
        return currencies;
    };
    
    var get_bitcoin = function() {
        $.getJSON("http://blockchain.info/ticker", function(ret){
            currencies['BTC'] = new Currency("BTC", "Bitcoin", 1 / ret.USD.buy);
        });
    };
    
    var get_exchange_rates = function() {
//        $.getJSON('http://finance.yahoo.com/webservice/v1/symbols/allcurrencies/quote?format=json&random=' + new Date().getTime(), function(ret){
//            var rates = ret.list.resources;
//            
//            for(var i in rates)
//            {
//                var code = rates[i].resource.fields.name.substr(4, 6);
//                
//                if(currenciesList[code] !== undefined)
//                {
//                    currencies[code] = new Currency(code, currenciesList[code].name, rates[i].resource.fields.price);
//                }
//            }
//        });
        
        var xhr = new XMLHttpRequest({mozSystem: true});
        xhr.open("GET", 'http://finance.yahoo.com/webservice/v1/symbols/allcurrencies/quote?format=json&random=' + new Date().getTime(), true);
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4) {
                var rates = ret.list.resources;
            
                for(var i in rates)
                {
                    var code = rates[i].resource.fields.name.substr(4, 6);

                    if(currenciesList[code] !== undefined)
                    {
                        currencies[code] = new Currency(code, currenciesList[code].name, rates[i].resource.fields.price);
                    }
                }
            }
        };
        xhr.send();
    };
    
    refreshRate();
}

function Currency(symbol, name, toUSD)
{
    this.symbol = symbol;
    this.name = name;
    this.forOneUSD = toUSD;
}