/* 
 * @file        4dcc.js
 * @version     v1.0.1
 * @createDate  10-May-14
 * @author      Chonchanok MueangRuangWit
 * @copyRight   4DBag Software 2014
 */

var _4DCC = function ()
{
    // Private variables
    var currencies = new Array();
    var URL_YAHOO_API = 'http://finance.yahoo.com/webservice/v1/symbols/allcurrencies/quote?format=json&random=' + new Date().getTime();
    var URL_BITCOIN_API = "http://blockchain.info/ticker";
    var AJAX_STATE_OK = 4;
    
    
    //Public method
    this.convert = function (from, to, volume)
    {
        if(! (from in currencies) || ! (to in currencies)) return false;
        
        if(from === "USD")
            return currencies[to].forOneUSD * volume;
        else if( to === "USD")
            return ( 1 / currencies[from].forOneUSD ) * volume;
        else
            return ( currencies[to].forOneUSD / currencies[from].forOneUSD ) * volume;
    };
    
    // Private method
    var refreshRate = function ()
    {
        
    };
    
    this.getCurrenciesList = function getCurrenciesList()
    {
        return currencies;
    };
    
    var ajaxHelper = function ( url, fn)
    {
        var xhr = new XMLHttpRequest({mozSystem: true});
        xhr.open("GET", url, true);
        xhr.responseType = "text";

        xhr.onload = fn;
        xhr.onerror = function () {
            alert("Error with System XHR");
        };
        xhr.send();
    };
    
    this.get_exchange_rates = function()
    {
        ajaxHelper(URL_YAHOO_API, function(){
            var rates = JSON.parse(this.response).list.resources;
            for(var i in rates)
            {
                var code = rates[i].resource.fields.name.substr(4, 6);
                
                if(currenciesList[code] !== undefined)
                {
                    currencies[code] = new Currency(code, currenciesList[code].name, rates[i].resource.fields.price);
                }
            }
        });
    };
    
    
    
    //Construction Zone
    refreshRate();
};

function Currency(symbol, name, toUSD)
{
    this.symbol = symbol;
    this.name = name;
    this.forOneUSD = toUSD;
}